/**
 * Created with JetBrains WebStorm.
 * User: julian
 * Date: 06/05/13
 * Time: 10:22
 */

var CalculatorForm = function () {

	var CalculatorForm = function ($container) {

		this.changed = new signals.Signal();
		this.$container = $container;
		this.calculator = new NetworkCalculator();

		var self = this;
		$('.txt-input', this.$container).keyup(function () {
			self.calculateTime(true);
		});
		$('.unit-input', this.$container).change(function () {
			self.calculateTime(true);
		});
		this.$timeUnit = $('#time-unit', this.$container);
		this.$timeUnit.selectmenu();
		this.$timeUnit.change(function () {
			self.calculateTime(false);
		});
	};

	var api = CalculatorForm.prototype;

	api.calculateTime = function calculateTime(adjust_time_unit) {

		var fs = $('#filesize', this.$container).val();
		var fsu = $('#filesize-unit', this.$container).val();

		var bytes = this.calculator.getBytes(fs, fsu);

		var s = $('#speed', this.$container).val();
		var su = $('#speed-unit', this.$container).val();

		var bps = this.calculator.getBitsPerSecond(s, su);

		var time = this.calculator.calculateTime(bytes, bps);
		var time_val = time;
		var time_unit = $('#time-unit', this.$container).val();

		if (adjust_time_unit) {
			time_unit = 'day';
			if (time_val < 24 * 3600)
				time_unit = 'hour';
			if (time_val < 3600)
				time_unit = 'min';
			if (time_val < 120)
				time_unit = 'sec';
			//
			this.$timeUnit.val(time_unit);
			this.$timeUnit.selectmenu("refresh", true);
		}
		time_val = this.roundFloat(this.calculator.getTimeInUnit(time, time_unit));
		$('#time', this.$container).html(time_val);
		this.changed.dispatch();
	};

	api.roundFloat = function roundFloat(val) {
		var m = 10;
		return Math.round(val * m) / m;
	};

	return CalculatorForm;

}();
