/**
 * Created with JetBrains WebStorm.
 * User: julian
 * Date: 06/05/13
 * Time: 10:08
 */

var NetworkCalculator = function () {

	var NetworkCalculator = function NetworkCalculator() {
		this.sizeUnits = {'kb': 1024, 'mb': 1024 * 1024, 'gb': 1024 * 1024 * 1000, 'tb': 1024 * 1024 * 1000 * 1000}; // base 10 - Wolfram|Alpha
		this.speedUnits = {'kbps': 1024, 'mbps': 1048576};
		this.timeUnits = {'sec': 1, 'min': 60, 'hour': 3600, 'day': 86400};
	};

	var api = NetworkCalculator.prototype;

	/**
	 * Calculates the time required to transfer a file.
	 * @param filesize in bytes
	 * @param speed in bits per second
	 * @returns {number} seconds
	 */
	api.calculateTime = function calculateTime(filesize, speed) {
		return filesize * 8 / speed;
	};

	api.getBytes = function getBytes(val, unit) {
		var mult = this.sizeUnits[unit];
		if (mult) {
			val = val * mult;
		}
		return val;
	};
	api.getBitsPerSecond = function getBitsPerSecond(val, unit) {
		var mult = this.speedUnits[unit];
		if (mult) {
			val = val * mult;
		}
		return val;
	};

	api.getTimeInUnit = function getTimeInUnit(secs, unit) {
		var rsp = 0;
		var div = this.timeUnits[unit];
		if (div) {
			rsp = secs / div;
		}
		return rsp;
	};
	api.getMinutes = function getMinutes(secs) {
		return secs / 60;
	};
	api.getHours = function getHours(secs) {
		return secs / 60 / 60;
	};

	return NetworkCalculator;
}();

